<?php
	/*
	 * Bildviz 0.2
	 *
	 * Anders Fjeldstad
	 * botta@home.se
	 *
	 * Bildviz r ett mycket enkelt bildgalleri som lter dig enkelt visa upp
	 * kataloger med bildinnehll p din webbplats. Det enda du behver gra r
	 * att stlla in i vilken katalog som alla bildkataloger ligger samt att
	 * sga hur stora thumbnailbilderna ska vara. Bildviz gr vid varje krning
	 * igenom dina bildkataloger och skapar eller tar bort thumbnailbilder.
	 *
	 * Det r helt okej att kopiera, anvnda, modifiera och sprida Bildviz
	 * s lnge som denna inledande kommentar finns med verst i alla filer.
	 *
	 * Fr att fungera krver Bildviz att PHP-biblioteket GD r aktiverat p
	 * webbservern. Detta behvs fr att skapa thumbnailbilder. Dessutom mste
	 * PHP/webbservern ha skrivrttigheter till thumbnailkatalogen.
	 *
	 * Tnk p att du inte kan ha vilka tecken som helst i dina katalognamn.
	 * Fr att Bildviz ska kunna hitta dina bilder fr katalognamnen bara inne-
	 * hlla tecknen 0-9, a-z, A-Z, -, _. Det kan hnda att andra tecken ocks
	 * funkar, men varfr chansa?
	 *
	 * Dessa filer ingr i Bildviz 0.2:
	 *
	 *    index.php				Sjlva gallerisidan som visar alla thumbnails.
	 *    bygg.php				Scriptet som skapar/tar bort thumbnails.
	 *    installningar.php	    Hr gr du instllningar fr Bildviz.
	 *    visa.php              Denna fil visar upp bilder i full storlek.
	 *    vanster.gif
	 *    upp.gif
	 *    hoger.gif
	 *
	 */	
	
	// Starta output buffering och sessionstd
	ob_start();
	session_start();
	
	// Ls in instllningar
	require_once('installningar.php');

	// G igenom bildkatalogstrukturen och synka mot thumbnailkatalogstrukturen.
	if (strlen($_SESSION['jobb']) == 0) {
		
		// Scanna bildkatalogen och leta efter thumbnails att skapa.
		$_SESSION['attSkapaThumbsAv'] = array();
		scannaKatalog($BILDROT, $BILDROT, $THUMBSROT);	
		
		// G igenom thumbnailkatalogen och ta bort thumbnails som inte har
		// motsvarande bilder i bildkatalogen.	
		rensaThumbs($THUMBSROT, $BILDROT, $THUMBSROT);
		
		// Om det finns thumbnails att skapa, ladda om scriptet.
		if (count($_SESSION['attSkapaThumbsAv']) > 0) {
			$_SESSION['jobb'] = implode('|', $_SESSION['attSkapaThumbsAv']);
			$_SESSION['attSkapaThumbsAv'] = '';
			header('Location: bygg.php');
			exit();
			
		// Annars, skriv ut ett meddelande som berttar fr anvndaren att
		// allt r klart.
		} else {
			$allaOperationerKlara = true;
		}
		
	// G igenom alla bilder som lagts p k och skapa thumbnails.
	} else {
		$attSkapaThumbsAv = explode('|', $_SESSION['jobb']);
		$anropstid = time();
		while ((count($attSkapaThumbsAv) > 0) && (time() - $anropstid < 20)) {
			$bildfil = array_pop($attSkapaThumbsAv);
			echo 'Frfluten tid: ' . (time() - $anropstid) . '<br/>';
			echo 'Skapar thumbnail fr ' . $bildfil . ', ' . $BILDROT . ', ' . $THUMBSROT . '<br/>';
			skapaThumb($bildfil, $BILDROT, $THUMBSROT, 
					   $THUMBNAILSTORLEK, $THUMBNAILKVALITET);
		}
		
		// Om alla thumbnails skapats, sg till att det r klart!
		if (count($attSkapaThumbsAv) == 0) {
			$_SESSION['jobb'] = '';
			
		// Om det finns thumbs kvar att skapa, lagra en ny strng med bildnamn.
		} else {
			$_SESSION['jobb'] = implode('|', $attSkapaThumbsAv);
		}
		
		// Ladda om scriptet efter 20 sekunder fr att undvika att PHP:s
		// exekveringstidsgrns verskrids, alternativt ladda om nr alla
		// thumbnails skapats.
		header('Location: bygg.php');
		exit();
	}
	
	/*
	 * scannaKatalog($katalog, $bildrot, $thumbsrot)
	 *
	 * Gr rekursivt igenom underkataloger och filer i den angivna katalogen
	 * och kollar om de bilder som hittas finns i motsvarande struktur
	 * i thumbnailkatalogen.
	 */
	function scannaKatalog($katalog, $bildrot, $thumbsrot) {
		// Ls in alla underkataloger.
		$underkataloger = glob($katalog . '/*', GLOB_ONLYDIR);
		for ($i = 0; $i < count($underkataloger); $i++) {
			// Kolla om motsvarande thumbs-katalog finns, om inte skapa.
			$thumbskat = str_replace($bildrot, $thumbsrot, $underkataloger[$i]);
			if (!file_exists($thumbskat)) {
				mkdir($thumbskat);
			}
			
			// Scanna underkataloger rekursivt.
			scannaKatalog($underkataloger[$i], $bildrot, $thumbsrot);
		}
		
		// Ls in alla bildfiler av typ jpg, png och gif.
		$filer = glob($katalog . '/{*.jpg,*.JPG,*.png,*.PNG,*.gif,*.GIF}', GLOB_BRACE);
		for ($i = 0; $i < count($filer); $i++) {
			// Kolla om bilden har en thumbnail, annars lggs den p k.
			$thumb = str_replace($bildrot, $thumbsrot, $filer[$i]);
			$thumb = substr_replace($thumb, 'jpg', -3, 3);
			if (!file_exists($thumb)) {
				array_push($_SESSION['attSkapaThumbsAv'], $filer[$i]);
			}
		}
	}
	
	/*
	 * rensaThumbs($katalog, $bildrot, $thumbsrot)
	 *
	 * Gr rekursivt igenom alla underkataloger och filer i thumbskatalogen
	 * och tar bort dem om de inte har en motsvarighet i bildkatalogen.
	 */
	function rensaThumbs($katalog, $bildrot, $thumbsrot) {
		// Ls in alla underkataloger.
		$underkataloger = glob($katalog . '/*', GLOB_ONLYDIR);
		for ($i = 0; $i < count($underkataloger); $i++) {
			// Kolla om motsvarande bildkatalog finns, om inte ta bort.
			$bildkat = str_replace($thumbsrot, $bildrot, $underkataloger[$i]);
			if (!file_exists($bildkat)) {
				taBortKatalog($underkataloger[$i]);
				
			} else {
				// Scanna underkataloger rekursivt.
				rensaThumbs($underkataloger[$i], $bildrot, $thumbsrot);
			}
		}
		
		// Ls in alla bildfiler av typ jpg, png och gif.
		$filer = glob($katalog . '/{*.jpg,*.JPG,*.png,*.PNG,*.gif,*.GIF}', GLOB_BRACE);
		for ($i = 0; $i < count($filer); $i++) {
			// Kolla om motsvarande bild finns, annars tars thumbnailen bort.
			$bildjpg = str_replace($thumbsrot, $bildrot, $filer[$i]);
			$bildJPG = substr_replace($bildjpg, 'JPG', -3, 3);
			$bildpng = substr_replace($bildjpg, 'png', -3, 3);
			$bildPNG = substr_replace($bildjpg, 'PNG', -3, 3);
			$bildgif = substr_replace($bildjpg, 'gif', -3, 3);
			$bildGIF = substr_replace($bildjpg, 'GIF', -3, 3);
			if (!file_exists($bildjpg) && !file_exists($bildJPG) &&
				!file_exists($bildpng) && !file_exists($bildPNG) &&
				!file_exists($bildgif) && !file_exists($bildGIF)) {
					
				unlink($filer[$i]);
			}
		}
	}
	
	/*
	 * taBortKatalog($katalog)
	 *
	 * Tar rekursivt bort alla filer och underkataloger och avslutar med att
	 * ta bort sjlva katalogen.
	 */
	function taBortKatalog($katalog) {
		// Rekursiv borttagning av underkataloger
		$underkataloger = glob($katalog . '/*', GLOB_ONLYDIR);
		for ($i = 0; $i < count($underkataloger); $i++) {
			taBortKatalog($underkataloger[$i]);
		}
		
		// Borttagning av filer i denna katalog
		$filer = glob($katalog . '/*.*');
		for ($i = 0; $i < count($filer); $i++) {
			unlink($filer[$i]);
		}
		
		// Ta bort denna katalog
		rmdir($katalog);
	}
	
	/*
	 * skapaThumb($bildfil, $bildrot, $thumbsrot)
	 *
	 * Skapar en thumbnail till den angivna bildfilen och placerar den p
	 * motsvarande stlle i thumbskatalogstrukturen.
	 */
	function skapaThumb($bildfil, $bildrot, $thumbsrot, $thumbstorlek, $thumbkvalitet) {
		$thumbfil = str_replace($bildrot, $thumbsrot, $bildfil);
		$thumbfil = substr_replace($thumbfil, 'jpg', -3, 3);
		
		if (exif_imagetype($bildfil) == IMAGETYPE_GIF) {
			$bild = imagecreatefromgif($bildfil);

		} elseif (exif_imagetype($bildfil) == IMAGETYPE_PNG) {
			$bild = imagecreatefrompng($bildfil);

		} elseif (exif_imagetype($bildfil) == IMAGETYPE_JPEG) {
			$bild = imagecreatefromjpeg($bildfil);

		} else {
			echo 'Kunde inte skapa thumbnail fr ' . $bildfil . ' eftersom ' .
				 'formatet inte stds av Bildviz.<br/>';
			return;
		}
		
		// Rkna ut dimensioner fr thumbnailbilden.
		$bildB = imagesx($bild);
		$bildH = imagesy($bild);
		$ratio = $bildB / $bildH;
		$thumbB = round($bildB > $bildH ? $thumbstorlek : $ratio*$thumbstorlek);
		$thumbH = round($bildB > $bildH ? $thumbstorlek/$ratio : $thumbstorlek);
		
		// Skapa och spara thumbnailbild.
		$thumb = imagecreatetruecolor($thumbB, $thumbH);
		imagecopyresampled($thumb, $bild, 0, 0, 0, 0, $thumbB, $thumbH, $bildB, $bildH);
		imagejpeg($thumb, $thumbfil, $thumbkvalitet);
	}
?>
<?php if ($allaOperationerKlara) { ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
	<head>
		<title>Bildviz 0.2</title>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
		<meta name="author" content="Anders Fjeldstad"/>
		<style type="text/css">
			body {
				background-color: #FFFFFF;
				margin: 30px;
			}
			
			h3 {
				font-family: "Trebuchet MS", Verdana, sans-serif;
				font-size: 16px;
				font-weight: bold;
				color: #345678;
				margin: 20px 0px 5px 0px;
			}
			
			p {
				font-family: "Trebuchet MS", Verdana, sans-serif;
				font-size: 12px;
				color: #000000;
				margin: 0px 0px 10px 0px;
				width: 300px;
			}
			
			a {
				color: #876543;
				text-decoration: none;
			}
			
			a:hover {
				text-decoration: underline;
			}
		</style>
	</head>
	<body>
		<h3>Alla operationer klara</h3>
		<p>
			Bildviz har nu gtt igenom dina bildkataloger och skapat thumbnails
			fr de nya bilderna samt tagit bort gamla thumbnails som inte lngre
			har ngra bilder.
		</p>
		<p>
			<a href="index.php">Klicka hr</a> fr att titta i galleriet!
		</p>
	</body>
</html>
<?php } ?>
